<?php
// $Id: setup.php 309 2007-07-27 16:52:32Z Hal9000 $

/** ensure this file is being included by a parent file */
defined( '_VALID_PARENT' ) or die("<html><head><meta http-equiv=\"Refresh\" content=\"0;URL=index.php\" /></head><body><a href=\"index.php\">Start Setup</a></body></html>");

/* Turns reporting on until config is loaded */
ini_set('display_errors','on');
error_reporting(E_ALL);

/* Preliminary Checks */
if (extension_loaded('mysql') == 1) { $check_str3 = "<span style=\"color:green\">Present</span>"; }
else {
	die("<span style=\"color:red\">ERROR</span>: PHP MySQL extension is missing!<br />This component is required to run phpDenora. Please contact your Administrator.");
}

/* Step 1 Checks */
$denoraver = phpdenora_versioncheck($denora_server_name,'full');
$denoranum = phpdenora_versioncheck($denora_server_name,'num');
$denorarev = phpdenora_versioncheck($denora_server_name,'rev');

if ($denoraver == NULL) {
	if (sql_errno() != 0) {
		echo "<span style=\"color:red\">MySQL Error</span> " . sql_errno() . ": " . sql_error(). "<br />";
		die("Please ensure that the database is setup correctly, and that the MySQL login data you specified in phpdenora.cfg.php is correct.");
	} else {
		die("<span style=\"color:red\">ERROR:</span> The database seems to be empty.<br />
			Please do the following checks:<br />
			<ul><li>Ensure that your Denora server is setup correctly, connected to your irc network and running.<br />
			Yes, you NEED a Denora server running on your irc network in order to use phpDenora.<br />
			Get Denora from <a href=\"http://denorastats.org/\">http://denorastats.org/</a></li>
			<li>Check your Denora log file for any mysql-related errors.</li>
			<li>In the phpDenora configuration file you specified <em>$denora_server_name</em> as Denora server name.<br />
			Please ensure that this is the EXACT same name you gave to your Denora server on your irc network.</li></ul>
			");
	}
}
if ($denoranum < '1.2') {
	if ($denorarev < 449) { $check_str1 = "<span style=\"color:red\">Incompatible</span><br />You need Denora 1.1.0 or greater to use phpDenora!"; }
elseif ($denorarev < 510 && $pd_ennetgraphs == true) { $check_str1 = "<span style=\"color:orange\">Warning</span><br />Your Denora version does not support Network Graphs correctly. Please set \$pd_ennetgraphs to false in the phpDenora configuration file, or upgrade to Denora 1.2"; }
} else {
	$check_str1 = "<span style=\"color:green\">Supported</span>";
}
$phpver = phpversion();
if (version_compare("4.3.2", phpversion(), "<") == 1) { $check_str2 = "<span style=\"color:green\">Supported</span>"; }
else { $check_str2 = "<span style=\"color:red\">Not Supported</span><br />You need at least version 4.3.2"; }
if (extension_loaded('gd') == 1) { $check_str4 = "<span style=\"color:green\">Present</span>"; }
else { $check_str4 = "<span style=\"color:red\">Missing</span><br />graphical features will be disabled"; }

/* Step 2 Checks */
$checkdb = isset($_POST['DBcheck']) ? $_POST['DBcheck'] : NULL;
$dbres = NULL; $dbres2 = NULL;
if ($checkdb != NULL) {
	$dbcheck = sql_query_num_rows("SELECT type FROM ".$denora_maxvalues.";"); /* Fix Denora bug #122 */
	if ($dbcheck < 4) {
		sql_query("INSERT INTO `$denora_maxvalues` (`type`, `val`, `time`) VALUES ('users', 0, '0000-00-00 00:00:00');");
		sql_query("INSERT INTO `$denora_maxvalues` (`type`, `val`, `time`) VALUES ('channels', 0, '0000-00-00 00:00:00');");
		sql_query("INSERT INTO `$denora_maxvalues` (`type`, `val`, `time`) VALUES ('servers', 0, '0000-00-00 00:00:00');");
		sql_query("INSERT INTO `$denora_maxvalues` (`type`, `val`, `time`) VALUES ('opers', 0, '0000-00-00 00:00:00');");
		$dbres .= "<span style=\"color:red\">Notice: </span>Fixed the $denora_maxvalues table (Denora bug 122).<br />";
	}
	$dbcheck2 = sql_query_num_rows("SELECT type FROM ".$denora_current_db.";"); /* Fix Denora bug #142 */
	if ($dbcheck2 < 5) {
		sql_query("INSERT INTO `$denora_current_db` VALUES ('chans', 0, 0);");
		$dbres .= "<span style=\"color:red\">Notice: </span>Fixed the $denora_current_db table (Denora bug 142).<br />";
	}
	/* Fix Denora bug #107 */
	$dbres .= fix_hourly_stats($denora_userstats);
	$dbres .= fix_hourly_stats($denora_channelstats);
	$dbres .= fix_hourly_stats($denora_serverstats);
	if ($dbres == NULL) {
		$dbres = "<span style=\"color:green\">Passed: </span>your database seems to be ok.<br />";
	}
}

function fix_hourly_stats($table) {
	$str = NULL; $fixcount = 0; $last_data = 0;
	
	/* First, we process the first day */
	$q = sql_query("SELECT * FROM $table WHERE id='1'");
	$r = sql_fetch_array($q);
	$i = 4;
	while ($r[$i] == 0) { /* Determine first stats value */
		$i++;
		if ($i > 26) {
			return NULL;
		}
	}
	$first_value = $i;
	
	/* Now we process the last day (current) */
	$q = sql_query("SELECT * FROM `$table` ORDER BY `$table`.`id` DESC LIMIT 1");
	$r = sql_fetch_array($q);
	$last_id = $r['id'];
	$i = 27;
	while ($r[$i] == 0) { /* Determine last stats value */
		$i--;
	}
	$last_value = $i;

	
	/* Now we process all the rest :) */
	$q = sql_query("SELECT * FROM `$table`");
	while ($r = sql_fetch_array($q)) {
		if ($r[0] == 1) {
			$i = $first_value;
		}
		else {
			$i = 4;
		}
		if ($r[0] == $last_id) {
			$imax = $last_value;
		}
		else {
			$imax = 28;
		}
		while ($i < $imax) {
			if ($r[$i] == 0) {
				if ($i == 4) {
					$r[$i] = $last_data;
				}
				else {
					$r[$i] = $r[$i - 1];
				}
				sql_update_data($table,'time_'.($i - 4),$r[$i],'id',$r[0]);
				$fixcount++;
			}
			$last_data = $r[$i];
			$i++;			
		}
	}
	
	if ($fixcount != 0) {
		$str .= "<span style=\"color:red\">Notice: </span>Fixed $fixcount values in $table (Denora bug 107).<br />";
	}
	
	return $str;
}

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>phpDenora :: Setup</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<style type="text/css">
<!--
body {
	background-color: #555967;
	margin: 0px;
	font-family: Verdana, Arial, Helvetica, sans-serif;
	font-size: 10px;
	color: #666666;
}

div#frame {
	margin: 7px auto 5px auto;
	padding: 0px;
	text-align: left;
	width: 550px;
}

div#header {
	padding: 5px 2px 2px 2px;
	margin: 0px;
	text-align:left;
	height: 58px;
	color: #003366;
	border-bottom: 2px solid #FF9900;
	border-left: 1px solid #CCCCCC;
	border-top: 1px solid #CCCCCC;
	border-right: 1px solid #CCCCCC;
	background-color:#FFFFFF;
}

div#main {
	padding: 0px;
	margin: 0px;
	background-color: #FFFFFF;
	border-left: 1px solid #CCCCCC;
	border-right: 1px solid #CCCCCC;
	text-align:left;
}

div#footer {
	padding: 0px;
	margin: 0px 0px 15px 0px;
	border-top: 1px solid #CCCCCC;
	font-size: 7pt;
	color: #999999;
	text-align: right;
}

img {
	border: 0;
	margin: 0;
}

p,h1,h3 {
	margin: 0px 10px 10px 10px;
	padding: 0px 5px 0px 5px;
}

p{
	font-family: Verdana, Arial, Helvetica, sans-serif;
	font-size: 8pt;
	font-style: normal;
	line-height: normal;
	font-weight: normal;
	font-variant: normal;
	text-transform: none;
	color: #666666;
	background-color: transparent;
	letter-spacing: normal;
	text-indent: 0pt;
	vertical-align: baseline;
	margin: 0px;
	text-align: justify;
}

h1{
	font-family: Verdana, Arial, Helvetica, sans-serif;
	font-size: 12pt;
	font-weight: bold;
	font-style: normal;
	font-variant: small-caps;
	color: #333333;
	background-color: transparent;
	margin: 0px;
}

h3 {
	font-family: Verdana, Arial, Helvetica, sans-serif;
	font-size: 10pt;
	font-weight: bold;
	font-style: normal;
	font-variant: small-caps;
	color: #666666;
	background-color: transparent;
	margin: 0px;
	text-align: left;
}


a, a:link, a:visited {
	color: #FF9900;
	text-decoration: none;
}
a:hover {
	text-decoration: underline;
}

form {
	padding: 5px;
	margin: 0px auto 0px auto;
	text-align: left;
}
input,select,textarea{ font-size: 8pt; }

-->
</style>
</head>
<body>
<div id="frame">
  <div id="header">
    <table width="100%" border="0" cellpadding="0" cellspacing="0">
      <tr>
        <td valign="middle"><a href="http://denorastats.org/"><img src="img/logo.png" /></a> </td>
        <td align="right" valign="bottom"><h1>phpDenora Setup</h1></td>
      </tr>
    </table>
  </div>
  <div id="main">
    <p>&nbsp;</p>
    <p><strong>Welcome to phpDenora! </strong></p>
    <p>If you are reading this you already configured phpDenora and it successfully connected to the Denora database.<br />
      This is good. However, there are still a couple of steps to complete.</p>
    <p>&nbsp;</p>
    <h3>1. Compatibility Check</h3>
    <table border="0" cellspacing="2" cellpadding="2">
      <tr>
        <th align="right"><?php echo $denoraver; ?>:</th>
        <td align="left"><?php echo $check_str1; ?> </td>
      </tr>
      <tr>
        <th align="right">PHP <?php echo $phpver; ?>:</th>
        <td align="left"><?php echo $check_str2; ?> </td>
      </tr>
      <tr>
        <th align="right">MySQL Extension:</th>
        <td align="left"><?php echo $check_str3; ?> </td>
      </tr>
      <tr>
        <th align="right">GD Extension:</th>
        <td align="left"><?php echo $check_str4; ?> </td>
      </tr>
    </table>
    <p>&nbsp;</p>
    <h3>2. Database Check</h3>
	<?php
		if ($checkdb == NULL && $dbres2 == NULL) {
	?>
	<p>phpDenora can check for known Denora bugs in the database and fix them.<br />
	It is STRONGLY recommended to do this, especially if you used Denora versions older than 1.2 in the past.</p>
    <form id="dbfix" method="post" action="index.php">
      <input type="submit" name="DBcheck" value="Check" />
    </form>
	<?php
		} elseif ($dbres2 != NULL) { echo "<p>$dbres2</p>"; }
		else { echo "<p>$dbres</p>"; }
	?>
    <p>&nbsp;</p>
    <h3>3. Network Registration <em>(optional) </em></h3>
    <p>Please tell us about your network, so we can list you on the phpDenora web site and inform you about new releases via the announce mailing list.<br />
    You only need to submit this form once. </p>
    <form id="registration" method="post" action="http://denorastats.org/register.php">
      <table border="0" cellspacing="2" cellpadding="2">
        <tr>
          <td align="right"><strong>Network Name:</strong></td>
          <td><?php echo $pd_netname;?></td>
        </tr>
        <tr>
          <td align="right"><strong>Network Homepage URL: </strong></td>
          <td><?php echo $pd_neturl;?></td>
        </tr>
        <tr>
          <td align="right"><strong>phpDenora URL: </strong></td>
          <td>http://<?php echo $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']; ?></td>
        </tr>
        <tr>
          <td align="right"><strong>Email address:</strong></td>
          <td><input name="email" type="text" size="30" /></td>
        </tr>
        <tr>
          <td>&nbsp;</td>
          <td>
		  <input type="hidden" name="netname" value="<?php echo $pd_netname; ?>" />
		  <input type="hidden" name="netpage" value="<?php echo $pd_neturl; ?>" />
		  <input type="hidden" name="homepage" value="<?php echo "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']; ?>" />
		  <input type="hidden" name="version" value="<?php echo VERSION_FULL; ?>" />
		  <input type="hidden" name="ircd" value="<?php echo $denora_server_type; ?>" />
            <input type="submit" name="Submit" value="Submit" /></td>
        </tr>
      </table>
    </form>
    <p>&nbsp;</p>
    <h3>4. Finalize the Installation</h3>
    <ul>
      <li><strong>Edit welcome.dist.php and rename it to welcome.php<br />
        </strong>You can customize the welcome page file to your needs and taste. You can welcome your users, describe your network, and put whatever information you want in there. 
        Please use XHTML 1.0 Strict compilant markup language to avoid breaking validation.</li>
      <li><strong>Remove setup.php</strong><br />
        You must REMOVE the setup.php file in order to start using phpDenora! </li>
    </ul>
    <h3>5. Important Notes</h3>
    <p>To submit any bugs please use the <a href="http://denorastats.org/mantis/">Bug Tracker</a>.</p>
    <p>&nbsp;</p>
  </div>
  <div id="footer">
    Powered by <a href="http://denorastats.org/">phpDenora</a> v<?php echo VERSION_FULL; ?>
  </div>
</div>
</body>
</html>
